Loading...
Searching...
No Matches
irr::scene::SMesh Struct Reference

Simple implementation of the IMesh interface. More...

`#include <SMesh.h>`

Inheritance diagram for irr::scene::SMesh:

## Public Member Functions

| SMesh ()
| constructor
virtual | ~SMesh ()
| destructor
void | addMeshBuffer (IMeshBuffer *buf)
| adds a MeshBuffer
virtual void | clear ()
| clean mesh
virtual const core::aabbox3d< f32 > & | getBoundingBox () const
| returns an axis aligned bounding box
virtual IMeshBuffer * | getMeshBuffer (const video::SMaterial &material) const
| returns a meshbuffer which fits a material
virtual IMeshBuffer * | getMeshBuffer (u32 nr) const
| returns pointer to a mesh buffer
virtual u32 | getMeshBufferCount () const
| returns amount of mesh buffers.
void | recalculateBoundingBox ()
| recalculates the bounding box
virtual void | setBoundingBox (const core::aabbox3df &box)
| set user axis aligned bounding box
virtual void | setDirty (E_BUFFER_TYPE buffer=EBT_VERTEX_AND_INDEX)
| flags the meshbuffer as changed, reloads hardware buffers
virtual void | setHardwareMappingHint (E_HARDWARE_MAPPING newMappingHint, E_BUFFER_TYPE buffer=EBT_VERTEX_AND_INDEX)
| set the hardware mapping hint, for driver
virtual void | setMaterialFlag (video::E_MATERIAL_FLAG flag, bool newvalue)
| sets a flag of all contained materials to a new value
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Public Attributes

core::aabbox3d< f32 > | BoundingBox
| The bounding box of this mesh.
core::array< IMeshBuffer * > | MeshBuffers
| The meshbuffers of this mesh.

## Additional Inherited Members

Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Detailed Description

Simple implementation of the IMesh interface.

Definition at line 18 of file SMesh.h.

## Constructor & Destructor Documentation

## SMesh()

irr::scene::SMesh::SMesh | ( |  | ) |

inline

constructor

Definition at line 21 of file SMesh.h.

References irr::IReferenceCounted::setDebugName().

## ~SMesh()

virtual irr::scene::SMesh::~SMesh | ( |  | ) |

inline virtual

destructor

Definition at line 29 of file SMesh.h.

References irr::IReferenceCounted::drop(), and MeshBuffers.

## Member Function Documentation

## addMeshBuffer()

void irr::scene::SMesh::addMeshBuffer | ( | IMeshBuffer * | buf | ) |

inline

adds a MeshBuffer

The bounding box is not updated automatically.

Definition at line 98 of file SMesh.h.

References irr::IReferenceCounted::grab(), and MeshBuffers.

## clear()

virtual void irr::scene::SMesh::clear | ( |  | ) |

inline virtual

clean mesh

Definition at line 37 of file SMesh.h.

References BoundingBox, irr::IReferenceCounted::drop(), and MeshBuffers.

## getBoundingBox()

virtual const core::aabbox3d< f32 > & irr::scene::SMesh::getBoundingBox | ( |  | ) | const

inline virtual

returns an axis aligned bounding box

Implements irr::scene::IMesh.

Definition at line 72 of file SMesh.h.

References BoundingBox.

## getMeshBuffer() [1/2]

virtual IMeshBuffer * irr::scene::SMesh::getMeshBuffer | ( | const video::SMaterial & | material | ) | const

inline virtual

returns a meshbuffer which fits a material

reverse search

Implements irr::scene::IMesh.

Definition at line 60 of file SMesh.h.

References MeshBuffers.

## getMeshBuffer() [2/2]

virtual IMeshBuffer * irr::scene::SMesh::getMeshBuffer | ( | u32 | nr | ) | const

inline virtual

returns pointer to a mesh buffer

Implements irr::scene::IMesh.

Definition at line 53 of file SMesh.h.

References MeshBuffers.

## getMeshBufferCount()

virtual u32 irr::scene::SMesh::getMeshBufferCount | ( |  | ) | const

inline virtual

returns amount of mesh buffers.

Implements irr::scene::IMesh.

Definition at line 47 of file SMesh.h.

References MeshBuffers.

## recalculateBoundingBox()

void irr::scene::SMesh::recalculateBoundingBox | ( |  | ) |

inline

recalculates the bounding box

Definition at line 84 of file SMesh.h.

References BoundingBox, and MeshBuffers.

## setBoundingBox()

virtual void irr::scene::SMesh::setBoundingBox | ( | const core::aabbox3df & | box | ) |

inline virtual

set user axis aligned bounding box

Implements irr::scene::IMesh.

Definition at line 78 of file SMesh.h.

References BoundingBox.

## setDirty()

virtual void irr::scene::SMesh::setDirty | ( | E_BUFFER_TYPE | buffer = EBT_VERTEX_AND_INDEX | ) |

inline virtual

flags the meshbuffer as changed, reloads hardware buffers

Implements irr::scene::IMesh.

Definition at line 122 of file SMesh.h.

References irr::scene::EBT_VERTEX_AND_INDEX, MeshBuffers, and setDirty().

Referenced by setDirty().

## setHardwareMappingHint()

virtual void irr::scene::SMesh::setHardwareMappingHint | ( | E_HARDWARE_MAPPING | newMappingHint,
|  | E_BUFFER_TYPE | buffer = EBT_VERTEX_AND_INDEX )

inline virtual

set the hardware mapping hint, for driver

Implements irr::scene::IMesh.

Definition at line 115 of file SMesh.h.

References irr::scene::EBT_VERTEX_AND_INDEX, MeshBuffers, and setHardwareMappingHint().

Referenced by setHardwareMappingHint().

## setMaterialFlag()

virtual void irr::scene::SMesh::setMaterialFlag | ( | video::E_MATERIAL_FLAG | flag,
|  | bool | newvalue )

inline virtual

sets a flag of all contained materials to a new value

Implements irr::scene::IMesh.

Definition at line 108 of file SMesh.h.

References MeshBuffers.

## Member Data Documentation

## BoundingBox

core::aabbox3d<f32> irr::scene::SMesh::BoundingBox

The bounding box of this mesh.

Definition at line 132 of file SMesh.h.

Referenced by clear(), getBoundingBox(), recalculateBoundingBox(), and setBoundingBox().

## MeshBuffers

core::array<IMeshBuffer*> irr::scene::SMesh::MeshBuffers

The meshbuffers of this mesh.

Definition at line 129 of file SMesh.h.

Referenced by ~SMesh(), addMeshBuffer(), clear(), getMeshBuffer(), getMeshBuffer(), getMeshBufferCount(), recalculateBoundingBox(), setDirty(), setHardwareMappingHint(), and setMaterialFlag().

The documentation for this struct was generated from the following file:

- SMesh.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0